'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Mangle;

var _namegen = require('./namegen');

var _namegen2 = _interopRequireDefault(_namegen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isFunction(binding) {
  return binding.path.isFunctionExpression() || binding.path.isFunctionDeclaration() || binding.path.isClassDeclaration() || binding.path.isClassExpression();
}

function renameIdentifiers(path) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$opts = _ref.opts;
  _ref$opts = _ref$opts === undefined ? {} : _ref$opts;
  var _ref$opts$keep_fnames = _ref$opts.keep_fnames;
  let keep_fnames = _ref$opts$keep_fnames === undefined ? false : _ref$opts$keep_fnames;

  const bindings = path.scope.getAllBindings();
  const ownBindings = Object.keys(bindings).filter(b => path.scope.hasOwnBinding(b));
  const names = (0, _namegen2.default)();

  ownBindings.filter(b => {
    if (!keep_fnames) return true;
    return !isFunction(path.scope.getBinding(b));
  }).map(b => {
    let next = names.next().value;
    while (path.scope.hasBinding(next)) {
      next = names.next().value;
    }
    path.scope.rename(b, next);
  });
}

function Mangle() {
  return {
    visitor: {
      Program: function Program(path, options) {
        if (options.opts && options.opts.mangle_globals) renameIdentifiers(path, options);
      },

      BlockStatement: renameIdentifiers
    }
  };
}
module.exports = exports['default'];